''' add different level labels to the set '''
# cifar 10 original data:
# airplane 0; automobile 1; bird 2; cat 3; deer 4; dog 5; frog 6; horse 7; ship 8; truck 9
# regroup:
# automobile, truck, 0; deer, horse, 1; cat, dog, 2; ship, airplane, 3; frog, bird, 4;
import numpy as np

def label_modified(label, dataset, task_level, labelfile=None):
  #label=label.numpy()
  if dataset == 'cifar10':
    if task_level == 'class':
      return label
    elif task_level == 'sclass':
      if label == 0:
        return 3
      if label == 1:
        return 0
      if label == 2:
        return 4
      if label == 3:
        return 2
      if label == 4:
        return 1
      if label == 5:
        return 2
      if label == 6:
        return 4
      if label == 7:
        return 1
      if label == 8:
        return 3
      if label == 9:
        return 0
    elif task_level == 'ssclass':
      if label == 0:
        return 0
      if label == 1:
        return 0
      if label == 8:
        return 0
      if label == 9:
        return 0
      return 1
  if dataset == 'cifar100':
    if task_level == 'class':
      return label
    coarse=np.zeros([20,5])
    coarse[0,:]=[4,31,55,72,95]
    coarse[1,:]=[1,33,67,73,91]
    coarse[2,:]=[54,62,70,82,92]
    coarse[3,:]=[9,10,16,29,61]
    coarse[4,:]=[0,51,53,57,83]
    coarse[5,:]=[22,25,40,86,87]
    coarse[6,:]=[5,20,26,84,94]
    coarse[7,:]=[6,7,14,18,24]
    coarse[8,:]=[3,42,43,88,97]
    coarse[9,:]=[12,17,38,68,76]
    coarse[10,:]=[23,34,49,60,71]
    coarse[11,:]=[15,19,21,32,39]
    coarse[12,:]=[35,63,64,66,75]
    coarse[13,:]=[27,45,77,79,99]
    coarse[14,:]=[2,11,36,46,98]
    coarse[15,:]=[28,30,44,78,93]
    coarse[16,:]=[37,50,65,74,80]
    coarse[17,:]=[47,52,56,59,96]
    coarse[18,:]=[8,13,48,58,90]
    coarse[19,:]=[41,69,81,85,89]
    if task_level == 'sssclass':
      label=label.numpy()
      temp=0
      for i in range(20):
        if label in coarse[i,:]:
          temp=i
      if temp in [0,8,11,12,16,14]:
        return 0
      if temp in [1,15,7,13]:
        return 1
      if temp in [18,19,3,5,6,9]:
        return 2
      if temp in [10,2,4,17]:
        return 3
    if task_level == 'ssclass':
      label=label.numpy()
      temp=0
      for i in range(20):
        if label in coarse[i,:]:
          temp=i
      if temp in [0,1]:
        return 0
      if temp in [8,11]:
        return 1
      if temp in [12,16]:
        return 2
      if temp in [18,19]:
        return 3
      if temp in [15,7,13]:
        return 4
      if temp in [14]:
        return 5
      if temp in [2,4,17]:
        return 6
      if temp in [3,5,6]:
        return 7
      if temp in [9]:
        return 8
      if temp in [10]:
        return 9
    if task_level == 'sclass':
      label=label.numpy()
      
      for i in range(20):
        if label in coarse[i,:]:
          return i
  if dataset == 'svhn':
    if task_level == 'svhn':
      return label
    elif task_level == 'svhn-2':
      if label in [0, 2, 4, 6, 8]:
        return 0
      else:
        return 1
  else:
    print('dataset setting not found in label.py')